"use strict";

exports.__esModule = true;

var _assert = require("assert");

var _assert2 = _interopRequireDefault(_assert);

var _bytebuffer = require("bytebuffer");

var _bytebuffer2 = _interopRequireDefault(_bytebuffer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var EthAddress = {
    fromId: function fromId(id) {
        var allowedTypes = ["1.2.", "1.16."];
        var type = void 0,
            index = void 0;
        for (var t in allowedTypes) {
            if (id.indexOf(allowedTypes[t]) == 0) {
                index = allowedTypes[t].length;
                type = t;
            }
        }
        (0, _assert2.default)(type >= 0, "unknown id type");
        (0, _assert2.default)(index, "unknown id type");
        var prefix = new Buffer([type]);
        var postfix = Buffer.from(parseInt(id.substr(index)).toString(16), 'hex');
        var totalLength = 20;
        var currentLength = prefix.length + postfix.length;

        var addr = Buffer.concat([prefix, new Buffer(totalLength - currentLength), postfix], totalLength);
        return addr.toString('hex');
    }
};

exports.default = EthAddress;
module.exports = exports["default"];