import assert from "assert";
import ByteBuffer from "bytebuffer";

var EthAddress = {
    fromId: function fromId(id) {
        var allowedTypes = ["1.2.", "1.16."];
        var type = void 0,
            index = void 0;
        for (var t in allowedTypes) {
            if (id.indexOf(allowedTypes[t]) == 0) {
                index = allowedTypes[t].length;
                type = t;
            }
        }
        assert(type >= 0, "unknown id type");
        assert(index, "unknown id type");
        var prefix = new Buffer([type]);
        var postfix = Buffer.from(parseInt(id.substr(index)).toString(16), 'hex');
        var totalLength = 20;
        var currentLength = prefix.length + postfix.length;

        var addr = Buffer.concat([prefix, new Buffer(totalLength - currentLength), postfix], totalLength);
        return addr.toString('hex');
    }
};

export default EthAddress;